<?php
if(isset($_REQUEST['stats']))
{
	$anz = 0;
	$size = 0;
	$ids = @(array)Shop::Cache()->getKeysByTag('supercache');
	foreach($ids as $id)
	{
		$x = Shop::Cache()->get($id);
		if($x)
		{
			$anz++;
			$size += mb_strlen($x);
		}
	}
	$base = log($size, 1024);
	$suffixes = array('', 'K', 'M', 'G', 'T');   

	$sizeFormatted = round(pow(1024, $base - floor($base)), 1) .' '. $suffixes[floor($base)]."B";

	if($anz == 0) $sizeFormatted = '-';

	$mysql = Shop::DB()->query('show table status where name=\'xplugin_km_supercache_data\';',2);
	$base = log($mysql[0]->Data_length, 1024);
	$sizeFormattedDB = round(pow(1024, $base - floor($base)), 1) .' '. $suffixes[floor($base)]."B";


	$files = glob(PFAD_ROOT.'includes/plugins/'.$oPlugin->cVerzeichnis.'/version/'.$oPlugin->nVersion.'/frontend/cache/*'); //get all file names
	$fileSize = 0; 
	foreach($files as $file)
	{
		if(is_file($file))
			$fileSize += filesize($file);
	}
	$base = log($fileSize, 1024);
	if($fileSize == 0) $sizeFormattedFile = '-';
	else
	$sizeFormattedFile = round(pow(1024, $base - floor($base)), 1) .' '. $suffixes[floor($base)]."B";

	$return = array(
		'anz' => $anz,
		'sizeCache' => $sizeFormatted,
		'sizeFiles' => $sizeFormattedFile,
		'sizeDB' => $sizeFormattedDB
	);
	
	header('Content-Type: application/json');
	http_response_code(200);
	die(json_encode($return));
}
?>
<div class="well">
	Nachfolgend die bereits im Cache gespeicherten Daten.<br>
	Bitte beachte dass wir den Supercache nur aktivieren wenn man nicht eingeloggt ist, keine Artikel im Warenkorb hat usw. - denn sonst w&uuml;rde das Ergebnis nicht stimmen.<br><br>
	Info: Der Datenbankcache hat immer eine Mindestgr&ouml;&szlig;e und gibt daher auch Werte bei leeren Daten zur&uuml;ck.
</div>
<?php
if(isset($_POST['clearSuperCache']))
{
	//JTL Cache leeren
	Shop::Cache()->flushTags(['supercache']);
	
	//Dateicache leeren
	$files = glob(PFAD_ROOT.'includes/plugins/'.$oPlugin->cVerzeichnis.'/version/'.$oPlugin->nVersion.'/frontend/cache/*'); //get all file names
	foreach($files as $file)
	{
		if(is_file($file))
			unlink($file);
	}
	
	//DB Cache leeren
	Shop::DB()->query('TRUNCATE `xplugin_km_supercache_data`',1);
	echo '<div class="alert alert-success"><i class="fa fa-info-circle"></i> SuperCache wurde erfolgreich geleert.</div>';
} 

if(isset($_POST['clearSuperCacheByURL']))
{
	$url = parse_url($_POST['clearUrl']);
	if($url && isset($url['path']))
	{
		Shop::Cache()->flushTags(str_replace('/','__',$url['path']));
		echo '<div class="alert alert-success"><i class="fa fa-info-circle"></i> Cache der URL <strong>'.$url['path'].'</strong> wurde erfolgreich geleert.</div>';
	}	
}
?>
<form method="post" action="" class="navbar-form">
<div class="panel panel-default first">
	<div class="panel-heading"><h3 class="panel-title">Cache nach URL leeren</h3></div>
	<div class="panel-body">
		<div class="input-group">
			<span class="input-group-addon">
				<label for="km_snackys_sale_prozent">Einzelne URL erneuern</label>
			</span>
			<span class="input-group-wrap">
				<input type="text" class="form-control" value="" id="clearUrl" name="clearUrl">
			</span>		
		</div>
	</div>
	<div class="panel-body">
		<div class="input-group">
			<button name="clearSuperCacheByURL" type="submit" value="Cache leeren" class="btn btn-primary"><i class="fa fa-save"></i> Cache nach URL leeren</button>
		</div>
	</div>
</div>
</form>


<div class="panel panel-default">
	<div class="panel-heading"><h3 class="panel-title">Statistik</h3></div>
	<div class="panel-body">
		<div class="input-group">
			<span class="input-group-addon">
				<label for="km_snackys_sale_prozent">Gecachte Seiten</label>
			</span>
			<span class="input-group-wrap">
				<input type="text" readonly="" class="form-control" value="Wird geladen ..." id="supercache_anz">
			</span>		
		</div>
		<div class="input-group">
			<span class="input-group-addon">
				<label for="km_snackys_sale_prozent">Gr&ouml;&szlig;e Standardcache</label>
			</span>
			<span class="input-group-wrap">
				<input type="text" readonly="" class="form-control" value="Wird geladen ..." id="supercache_sizeFormatted">
			</span>		
		</div>
		<div class="input-group">
			<span class="input-group-addon">
				<label for="km_snackys_sale_prozent">Gr&ouml;&szlig;e Dateicache</label>
			</span>
			<span class="input-group-wrap">
				<input type="text" readonly="" class="form-control" value="Wird geladen ..." id="supercache_sizeFormattedFile">
			</span>		
		</div>
		<div class="input-group">
			<span class="input-group-addon">
				<label for="km_snackys_sale_prozent">Gr&ouml;&szlig;e Datenbankcache</label>
			</span>
			<span class="input-group-wrap">
				<input type="text" readonly="" class="form-control" value="Wird geladen ..." id="supercache_sizeFormattedDB">
			</span>		
		</div>
	</div>
	<div class="panel-body">
		<div class="input-group">
			<form method="post" action="" class="navbar-form"><button name="clearSuperCache" type="submit" value="Cache leeren" class="btn btn-primary"><i class="fa fa-save"></i> gesamten Cache leeren</button></form>
		</div>
	</div>
</div>
<script type="text/javascript">
//Load Stats async, because of some big data will take long
var pluginUrl = 'plugin.php?kPlugin=<?php echo $oPlugin->kPlugin; ?>&stats=<?php echo time(); ?>';

function loadSupercacheStats()
{	
	var data = {io: '{"name": "km_live_update","params": []}'};
	$.ajax({
		url: pluginUrl,
		method: "GET"
	}).done(function (stats) {
		try
		{
			if(!stats)
				throw "dataError";
			$('#supercache_anz').val(stats.anz);
			$('#supercache_sizeFormatted').val(stats.sizeCache);
			$('#supercache_sizeFormattedFile').val(stats.sizeFiles);
			$('#supercache_sizeFormattedDB').val(stats.sizeDB);
		} catch (e) {
			$('#supercache_anz,#supercache_sizeFormatted,#supercache_sizeFormattedFile,#supercache_sizeFormattedDB').val('Fehler beim Laden');
		}
	});
}
loadSupercacheStats();

//Beim Klick auf cookie, diesen übernehmen
$(document).ready(function(){
	$('#km_supercache_cookie_dummmy').dblclick(function(e)
	{
		var val = $(this).val();
		var found = false;
		var free = false;
		for(var i=1;i<=30;i++)
		{
			if($('#km_supercache_cookie'+i).val() == "" && free == false)
				free = i;
			if($('#km_supercache_cookie'+i).val() == val && found == false)
				found = true;
			
			if(free != false && found != false)
				i= 31;
		}
		if(!found && free)
			$('#km_supercache_cookie'+free).val(val)
	});
});
</script>